/*
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 */




#include "w2lan.h"
#include "w2lan_input.h"
#include "w2lan_output.h"
#include "list.h"

#define MAX_STRING_LEN  10

static char mode[MAX_STRING_LEN];

module_param_string(mode,mode,sizeof(mode),0644);

MODULE_DESCRIPTION(DRIVER_DESC);
MODULE_AUTHOR(DRIVER_AUTHOR);
MODULE_VERSION(SOURCE_VERSION);
MODULE_LICENSE("GPL");

static struct ctl_table w2lan_table[] = {

     {
               .procname       = "w2lan_time_set",
               .data           = &w2lan_time,
               .maxlen         = sizeof(int),
               .mode           = 0644,
               .proc_handler   = proc_dointvec
     },
     {},
};

static struct ctl_path w2lan_path[] = {
        { .procname = "net", },
       	{ .procname = "w2lan", },
        { }
};


static struct ctl_table_header *w2lan_header;


static int __init w2lan_init(void)
{
      int err = -ENODEV;
      struct ctl_table *table;

      
      err = init_w2lan_output();
      if(err<0)    return err;
      
      init_w2lan_input();
      
      err =  list_init();

      if(err<0)
      {
	exit_w2lan_input();
	exit_w2lan_output();
	return  err;
      }

      w2lan_header = register_sysctl_paths(w2lan_path, w2lan_table);

      if (w2lan_header == NULL) return -1;


      if(strncmp(mode, "always"  ,6)==0)
		 w2lan_mode = W2LAN_MODE_ALWAYS;

      if(strncmp(mode, "passive" ,7)==0)
		 w2lan_mode = W2LAN_MODE_PASSIVE;
 	
      if(strncmp(mode, "reactive", 8)==0)
	 	 w2lan_mode = W2LAN_MODE_REACTIVE;


      
      return  0;
}


static void __exit w2lan_exit(void)
{    
    unregister_net_sysctl_table(w2lan_header);
    exit_w2lan_output();
    exit_w2lan_input();
    purge_w2lan_list();
}

module_init(w2lan_init);
module_exit(w2lan_exit);
