/*
 *  w2lan.h 
 *  
 *  Definiciones y estructuras para el protocolo w2lan
 * 
 */


#ifndef W2LAN_H
#define W2LAN_H


#define DRIVER_AUTHOR 		"Katfi Youssef <Katfiyoussef@hotmail.com>, " \

#define DRIVER_DESC 		"w2lan:Protocol that transforms a 802.11 mobile \
					ad-hoc network (MANET) into an ethernet LAN."

#ifndef SOURCE_VERSION
#define SOURCE_VERSION "2012.0.1"
#endif

/*Id protocol Announce */
#define W2LAN_A  0X6901
/*Id protocol Request  */
#define W2LAN_R  0X6902
/*Id protocol Data     */
#define W2LAN_D  0X6903

/********************/
#define DBGPRN1(X,Y)		if (debug) printk(KERN_DEBUG X,Y)

#define W2LAN_ETH_ALEN        	6
#define W2LAN_ETH_HLEN        	14

#define W2LAN_CONVID_LEN        6
#define W2LAN_ANNOUNCE_LEN      20
#define W2LAN_REQUEST_LEN       6
/*                 */
#define w2_flag    		0x69
#define proto_flag 		0x06

#define SEND_ANNOUNCE 		0x01
#define SEND_REQUEST 		0x02
#define SEND_DATA 		0x03

#define MaxConvID               10

#define W2_LIST_RX 		0
#define W2_LIST_TX 		1


#define W2_EXPIRY_TIME      (10 * HZ)


#define W2LAN_MODE_ALWAYS       0
#define W2LAN_MODE_PASSIVE      1
#define W2LAN_MODE_REACTIVE     2

/*
 * Kernel headers
 */

#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/types.h>
#include <linux/sysctl.h>
#include <linux/kernel.h>
#include <linux/etherdevice.h>
#include <linux/netdevice.h>
#include <linux/skbuff.h>


struct w2lan_convID
{
	unsigned char convID[W2LAN_CONVID_LEN];
	unsigned char orig_eth[W2LAN_ETH_HLEN];
	int pending;
	struct list_head list;
	atomic_t refcnt;
};

struct w2lan_hdr_rcv
{
	struct ethhdr eth;
	unsigned char convID[W2LAN_CONVID_LEN];
	unsigned char orig_eth[W2LAN_ETH_HLEN];
};

struct w2lan_data 
{
	unsigned char convID[W2LAN_CONVID_LEN];
	unsigned char orig_eth[W2LAN_ETH_HLEN];
	unsigned char *data;
	int len;
	int TX;
	int forward;
	int pending;
	int request;
	atomic_t refcnt; 
	
	struct list_head list;
 	struct timer_list timer;
};


#endif
