/*
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 */


#include "w2lan.h"
#include "list.h"
#include "w2lan_output.h"
#include "w2lan_input.h"


static int activewindow;

void printHex(char *mesg, unsigned char *p, int len)
{
        printk("%s\n", mesg);
        while(len--) {
	printk("%.2X ", *p);
	p++;
        }
        printk("\n");
}

int process_Announce(struct sk_buff *skb,struct w2lan_hdr_rcv *head)
{
	int ret = -ENOMEM;
	struct w2lan_data *w2=NULL;
      	activewindow = 1;

	w2 = get_data(head->convID,W2_LIST_RX);
	
	if(w2==NULL)	 /*Nueva Conversacion,crear y enviar un mensaje Request*/
	{
	  w2 = w2lan_alloc();
	  if(w2 == NULL )  
		    return ret;  
	  memcpy(w2->orig_eth,head->orig_eth,W2LAN_ETH_HLEN);
	  memcpy(w2->convID,head->convID,W2LAN_CONVID_LEN );
	  w2->TX = 0;
	  w2->pending=0;
	  w2->data=NULL;
	  	
	  ret = w2lan_send_frame(w2,head->eth.h_source,SEND_REQUEST);
	  set_w2lan_data(w2,W2_LIST_RX);
	}
	else put_foo(w2);

	return ret;  
      
}

int process_Request(struct sk_buff *skb,struct w2lan_hdr_rcv *head)
{
	int ret = -ENOMEM;
	struct w2lan_data *w2=NULL;

	w2 = get_data(head->convID,W2_LIST_TX);
	if(w2!=NULL)
	{ 
		if(w2->data!=NULL && w2->request == 0)
		{  
			w2lan_send_frame(w2,NULL,SEND_DATA);
			w2->request ++;
			put_foo(w2);
		}
	}
	return ret;
}

int w2_netif_rx(struct sk_buff *skb)
{
	  struct sk_buff *skb1 = NULL;
	  unsigned int skb_len = skb->len - W2LAN_ANNOUNCE_LEN;
  
 	  skb1 = netdev_alloc_skb(skb->dev,skb->len);

 	  if(skb1==NULL)
		 return 0; 
 	  skb1->dev = skb->dev;
	  memcpy(skb_put(skb1, W2LAN_ETH_HLEN),  skb->data, W2LAN_ETH_HLEN);
	  memcpy(skb_put(skb1, skb_len),  &skb->data[W2LAN_ANNOUNCE_LEN], skb_len);
	  skb1->protocol = eth_type_trans(skb1, skb1->dev);
	  netif_receive_skb(skb1);
	  return 1;
}

int process_Data(struct sk_buff *skb,struct w2lan_hdr_rcv *head)
{
	int ret = -ENOMEM;
	struct w2lan_data *w2=NULL;
	struct ethhdr *eth =NULL; 
	
	skb_reset_network_header(skb);
	
	w2 = get_data(head->convID,W2_LIST_RX);

	printHex("MAC ADDRESS process_Data (skb->dev->dev_addr):", skb->dev->dev_addr, 6);	

	if(w2!=NULL)
	{ 
	   eth=(struct ethhdr *)w2->orig_eth;

	   if (compare_ether_addr(eth->h_dest, skb->dev->dev_addr) != 0 || is_broadcast_ether_addr(eth->h_dest))
	    {
		
	        w2->forward = 1;			
		del_foo(w2,W2_LIST_RX);
		w2lan_list_add_TX(w2);
		
		w2->len = skb->len - W2LAN_REQUEST_LEN;
		
		if(w2->len > 0)        
		    w2->data = kmalloc(w2->len,GFP_ATOMIC);
		if(w2->data==NULL)
		{
		      w2->forward = 0;
		      goto end;
		}
		memcpy(w2->data,&skb->data[W2LAN_REQUEST_LEN],w2->len);  		
		w2lan_send_frame(w2,NULL,SEND_ANNOUNCE);
	   }

 	   if ((compare_ether_addr(eth->h_dest, skb->dev->dev_addr) == 0 || is_broadcast_ether_addr(eth->h_dest)) && 	
	       (compare_ether_addr(eth->h_source, skb->dev->dev_addr) != 0))
	   {
	        if(w2->pending == 0)
		{
			skb_push(skb,W2LAN_ETH_HLEN);
			memcpy(skb->data,w2->orig_eth,W2LAN_ETH_HLEN);
			w2_netif_rx(skb);
			w2->pending = 1;
		}		
	   }	   
	   
end:	   
	   put_foo(w2);
	}
	return ret;
}

static int w2lan_recv(struct sk_buff *skb, struct net_device *dv, struct packet_type *pt,struct net_device *org_dev) 
{
	
	struct w2lan_hdr_rcv *w2_hdr=NULL;
	struct sk_buff *skb2 = NULL;

	skb2 = skb_copy(skb,GFP_ATOMIC);
	kfree_skb(skb);

	if(skb2==NULL) goto out;  

	w2_hdr = (struct w2lan_hdr_rcv *)eth_hdr(skb2);


	if(compare_ether_addr(w2_hdr->eth.h_source,dv->dev_addr) == 0 || 
			compare_ether_addr(&w2_hdr->orig_eth[6],dv->dev_addr) == 0)		goto out_free;

	
 
	switch (ntohs(w2_hdr->eth.h_proto))
	{
	  
		case W2LAN_A: 
		if(is_duplicate(w2_hdr)== 0) process_Announce(skb2,w2_hdr); /**/
		break;
			
		case W2LAN_R:
		process_Request(skb2,w2_hdr);  
		break;
		
        	case W2LAN_D:
		process_Data(skb2,w2_hdr);  
		break;

		default:

		if(w2lan_mode != W2LAN_MODE_PASSIVE && dv == w2lan_dev){

			if(w2lan_mode == W2LAN_MODE_REACTIVE && activewindow != 1) 
				goto out;  
			skb = w2lan_generate_announce(skb2);
			dev_queue_xmit(skb);
			goto out;  				

		}
		/*passive mode: nada*/;
	}

out_free:
	kfree_skb(skb2);
	return 0;
out:		  

	return 0;	
}


static struct packet_type w2lan_packet_type = {
 		.type =htons(ETH_P_ALL),// __constant_htons(W2LAN),
 		.dev = NULL,
 		.func = w2lan_recv,
 }; 
 
void init_w2lan_input(void)
{
      dev_add_pack(&w2lan_packet_type);
}

void exit_w2lan_input(void)
{
      dev_remove_pack(&w2lan_packet_type);
}
